Yandex Cloud
Search
Discuss with expertTry it for free
  • Customer Stories
  • Documentation
  • Blog
  • All Services
    • Cloud Interconnect
    • Cloud Backup
    • Cloud Registry
    • Yandex AI Studio
    • Compute Cloud
    • Object Storage
    • Managed Service for Kubernetes®
    • Yandex BareMetal
    • Smart Web Security
    • Security Deck
    • Managed Service for PostgreSQL
    • Managed Service for ClickHouse®
    • Monium
    • Cloud CDN
    • Network Load Balancer
    • Virtual Private Cloud
    • Cloud DNS
    • Application Load Balancer
    • Yandex Cloud Video
    • Stackland
    • Yandex Cloud Router
    • Yandex Managed Service for Trino
    • Managed Service for MySQL®
    • Managed Service for Valkey™
    • Managed Service for Apache Spark™
    • Yandex StoreDoc
    • Managed Service for OpenSearch
    • Managed Service for Apache Kafka®
    • Data Transfer
    • Yandex MPP Analytics Engine for PostgreSQL
    • Yandex Managed Service for Apache Airflow®
    • Data Processing
    • Yandex MetaData Hub
    • Managed Service for YDB
    • Managed Service for Sharded PostgreSQL
    • Managed Service for YTsaurus
    • Yandex WebSQL
    • DataLens
    • Yandex Search API
    • SpeechSense
    • SpeechKit
    • DataSphere
    • Vision OCR
    • Translate
    • Yandex Identity Hub
    • Key Management Service
    • Certificate Manager
    • Yandex Lockbox
    • Audit Trails
    • SmartCaptcha
    • Cloud Desktop
    • SourceCraft Code Assistant
    • Container Registry
    • Managed Service for GitLab
    • Managed Service for Prometheus®
    • Cloud Functions
    • API Gateway
    • Yandex Cloud Postbox
    • Message Queue
    • Serverless Integrations
    • IoT Core
    • Data Streams
    • Serverless Containers
    • Cloud Notification Service
    • Yandex Query
    • Identity and Access Management
    • Yandex Cloud Console
    • Resource Manager
    • Yandex Cloud Billing
    • Yandex Cloud Quota Manager
    • Cloud Apps
  • System Status
  • Marketplace
    • Featured
    • Infrastructure & Network
    • Data Platform
    • AI for business
    • Security
    • DevOps tools
    • Serverless
    • Monitoring & Resources
  • All Solutions
    • By industry
    • By use case
    • Economics and Pricing
    • Security
    • Technical Support
    • Start testing with double trial credits
    • Cloud credits to scale your IT product
    • Gateway to Russia
    • Cloud for Startups
    • Center for Technologies and Society
    • Yandex Cloud Partner program
    • Price calculator
    • Pricing plans
  • Customer Stories
  • Documentation
  • Blog
© 2026 Direct Cursus Technology L.L.C.
Yandex Certificate Manager
  • Getting started
  • Access management
  • Pricing policy
  • Terraform reference
    • API authentication
      • Overview
        • Overview
          • Overview
          • GenerateCertificateAuthority
          • GenerateCertificateAuthorityByCsr
          • ImportCertificateAuthority
          • GenerateCsrForCertificateAuthority
          • SendSignedCertificateOfCertificateAuthority
          • Delete
          • GetCsrForCertificateAuthority
          • Get
          • List
          • Update
          • ListAccessBindings
          • SetAccessBindings
          • UpdateAccessBindings
  • Monitoring metrics
  • Audit Trails events
  • Release notes
  • FAQ

In this article:

  • HTTP request
  • Body parameters
  • Subject
  • BaseRDN
  • AdditionalRDN
  • Response
  • Status
  1. API reference
  2. REST
  3. Certificate Manager Private CA API
  4. PrivateCa
  5. GenerateCertificateAuthority

Certificate Manager Private CA API, REST: PrivateCa.GenerateCertificateAuthority

Written by
Yandex Cloud
Updated at July 1, 2026
View in Markdown
  • HTTP request
  • Body parameters
  • Subject
  • BaseRDN
  • AdditionalRDN
  • Response
  • Status

Generates a new Certificate Authority (CA).
This endpoint creates a new CA with given properties and cryptographic settings.

HTTP requestHTTP request

POST https://private-ca.certificate-manager.api.cloud.yandex.net/privateca/v1/certificateAuthorities:generate

Body parametersBody parameters

{
  "folderId": "string",
  "parentCertificateAuthorityId": "string",
  "name": "string",
  "description": "string",
  "subjectSpec": {
    "baseRdn": {
      "country": "string",
      "organization": "string",
      "organizationalUnit": "string",
      "distinguishedNameQualifier": "string",
      "stateOrProvince": "string",
      "commonName": "string",
      "emailAddress": "string"
    },
    "additionalRdn": {
      "serialNumber": "string",
      "locality": "string",
      "title": "string",
      "surname": "string",
      "givenName": "string",
      "initials": "string",
      "generationQualifier": "string"
    }
  },
  "algorithm": "string",
  "pathLen": "string",
  "keyUsage": [
    "string"
  ],
  "extendedKeyUsage": [
    "string"
  ],
  "ttlDays": "string",
  "endEntitiesTtlLimitDays": "string",
  "templateId": "string",
  "enableCrl": "boolean",
  "enableOcsp": "boolean",
  "deletionProtection": "boolean"
}

Request to generate a new Certificate Authority (CA).

Field

Description

folderId

string

Required field. Folder ID where the CA is being created.

The maximum string length in characters is 50.

parentCertificateAuthorityId

string

Optional. If set intermediate CA would be generated and signed on parent CA

The maximum string length in characters is 50.

name

string

Required field. The name of the Certificate Authority.

Value must match the regular expression |[a-z]([-a-z0-9]{0,61}[a-z0-9])?.

description

string

An optional description of the Certificate Authority.

The maximum string length in characters is 1024.

subjectSpec

Subject

Required field. The subject (e.g., common name, organization, etc.) for the CA.

algorithm

enum (Algorithm)

Required field. The algorithm for the asymmetric key generation (e.g., RSA, ECC).

  • RSA_2048_PSS_SHA_256
  • RSA_2048_PSS_SHA_384
  • RSA_2048_PSS_SHA_512
  • RSA_3072_PSS_SHA_256
  • RSA_3072_PSS_SHA_384
  • RSA_3072_PSS_SHA_512
  • RSA_4096_PSS_SHA_256
  • RSA_4096_PSS_SHA_384
  • RSA_4096_PSS_SHA_512
  • ECDSA_NIST_P256_SHA_256
  • ECDSA_NIST_P384_SHA_384
  • ECDSA_NIST_P521_SHA_512
  • ECDSA_SECP256_K1_SHA_256
  • RSA_2048_PKCS1_5_SHA_256: RSA PKCS 1.5
  • RSA_2048_PKCS1_5_SHA_384
  • RSA_2048_PKCS1_5_SHA_512
  • RSA_3072_PKCS1_5_SHA_256
  • RSA_3072_PKCS1_5_SHA_384
  • RSA_3072_PKCS1_5_SHA_512
  • RSA_4096_PKCS1_5_SHA_256
  • RSA_4096_PKCS1_5_SHA_384
  • RSA_4096_PKCS1_5_SHA_512

pathLen

string (int64)

The maximum length of the certificate chain.

keyUsage[]

enum (KeyUsageExtension)

Key usage (e.g., keyEncipherment, digitalSignature).

The maximum number of elements is 9.

  • DIGITAL_SIGNATURE
  • CONTENT_COMMITMENT
  • KEY_ENCIPHERMENT
  • DATA_ENCIPHERMENT
  • KEY_AGREEMENT
  • KEY_CERT_SIGN
  • CRL_SIGN
  • ENCIPHER_ONLY
  • DECIPHER_ONLY

extendedKeyUsage[]

enum (ExtendedKeyUsageExtension)

Extended key usage (e.g., serverAuth, clientAuth).

The maximum number of elements is 11.

  • SERVER_AUTH
  • CLIENT_AUTH
  • CODE_SIGNING
  • EMAIL_PROTECTION
  • TIME_STAMPING
  • OCSP_SIGNING
  • IPSEC_IKE
  • MS_CODE_IND
  • MS_CODE_COM
  • MS_CTL_SIGN
  • MS_EFS

ttlDays

string (int64)

The Time-To-Live (TTL) in days for the CA.

Acceptable values are 1 to 20000, inclusive.

endEntitiesTtlLimitDays

string (int64)

TTL limit in days for end-entities signed by the CA.

The maximum value is 20000.

templateId

string

Optional template ID to fill certificate fields with template data. Explicitly defined parameters is preferred

The maximum string length in characters is 50.

enableCrl

boolean

Enable Certificate Revocation List (CRL) support.

enableOcsp

boolean

Enable Online Certificate Status Protocol (OCSP) support.

deletionProtection

boolean

Protect the CA from accidental deletion. Deny deletion of ca if set

SubjectSubject

Subject field of certificate https://datatracker.ietf.org/doc/html/rfc5280#section-4.1.2.6

Field

Description

baseRdn

BaseRDN

Required field. Most used field of subject

additionalRdn

AdditionalRDN

Additional fields of subject

BaseRDNBaseRDN

https://datatracker.ietf.org/doc/html/rfc5280#section-4.1.2.4

Field

Description

country

string

Two letter county code

The maximum string length in characters is 2.

organization

string

Organization name in arbitrary form

The maximum string length in characters is 1000.

organizationalUnit

string

Organizational unit name in arbitrary form

The maximum string length in characters is 1000.

distinguishedNameQualifier

string

Distinguished name qualifier

The maximum string length in characters is 10000.

stateOrProvince

string

State or province name in arbitrary form

The maximum string length in characters is 1000.

commonName

string

Common name. For tls certificates it is domain usually.

The maximum string length in characters is 10000.

emailAddress

string

Email address of certificate owner

The maximum string length in characters is 1000.

AdditionalRDNAdditionalRDN

https://datatracker.ietf.org/doc/html/rfc5280#section-4.1.2.4

Field

Description

serialNumber

string

Serial number of certificate subject in arbitrary form. Don't confuse with certificate serial number.

The maximum string length in characters is 100.

locality

string

Locality of certificate subject in arbitrary form.

The maximum string length in characters is 1000.

title

string

Title of certificate subject in arbitrary form.

The maximum string length in characters is 1000.

surname

string

Surname of certificate subject in arbitrary form.

The maximum string length in characters is 1000.

givenName

string

Given name of certificate subject in arbitrary form.

The maximum string length in characters is 1000.

initials

string

Initials of certificate subject in arbitrary form.

The maximum string length in characters is 1000.

generationQualifier

string

Generation qualifier of certificate subject in arbitrary form.

The maximum string length in characters is 1000.

ResponseResponse

HTTP Code: 200 - OK

{
  "id": "string",
  "description": "string",
  "createdAt": "string",
  "createdBy": "string",
  "modifiedAt": "string",
  "done": "boolean",
  "metadata": "object",
  // Includes only one of the fields `error`, `response`
  "error": {
    "code": "integer",
    "message": "string",
    "details": [
      "object"
    ]
  },
  "response": "object"
  // end of the list of possible fields
}

An Operation resource. For more information, see Operation.

Field

Description

id

string

ID of the operation.

description

string

Description of the operation. 0-256 characters long.

createdAt

string (date-time)

Creation timestamp.

String in RFC3339 text format. The range of possible values is from
0001-01-01T00:00:00Z to 9999-12-31T23:59:59.999999999Z, i.e. from 0 to 9 digits for fractions of a second.

To work with values in this field, use the APIs described in the
Protocol Buffers reference.
In some languages, built-in datetime utilities do not support nanosecond precision (9 digits).

createdBy

string

ID of the user or service account who initiated the operation.

modifiedAt

string (date-time)

The time when the Operation resource was last modified.

String in RFC3339 text format. The range of possible values is from
0001-01-01T00:00:00Z to 9999-12-31T23:59:59.999999999Z, i.e. from 0 to 9 digits for fractions of a second.

To work with values in this field, use the APIs described in the
Protocol Buffers reference.
In some languages, built-in datetime utilities do not support nanosecond precision (9 digits).

done

boolean

If the value is false, it means the operation is still in progress.
If true, the operation is completed, and either error or response is available.

metadata

object

Service-specific metadata associated with the operation.
It typically contains the ID of the target resource that the operation is performed on.
Any method that returns a long-running operation should document the metadata type, if any.

error

Status

The error result of the operation in case of failure or cancellation.

Includes only one of the fields error, response.

The operation result.
If done == false and there was no failure detected, neither error nor response is set.
If done == false and there was a failure detected, error is set.
If done == true, exactly one of error or response is set.

response

object

The normal response of the operation in case of success.
If the original method returns no data on success, such as Delete,
the response is google.protobuf.Empty.
If the original method is the standard Create/Update,
the response should be the target resource of the operation.
Any method that returns a long-running operation should document the response type, if any.

Includes only one of the fields error, response.

The operation result.
If done == false and there was no failure detected, neither error nor response is set.
If done == false and there was a failure detected, error is set.
If done == true, exactly one of error or response is set.

StatusStatus

The error result of the operation in case of failure or cancellation.

Field

Description

code

integer (int32)

Error code. An enum value of google.rpc.Code.

message

string

An error message.

details[]

object

A list of messages that carry the error details.

Was the article helpful?

Previous
Overview
Next
GenerateCertificateAuthorityByCsr
© 2026 Direct Cursus Technology L.L.C.